# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Web::Mgmt::V2020_09_01
  module Models
    #
    # Description of the parameters of Private Access for a Web Site.
    #
    class PrivateAccess < ProxyOnlyResource

      include MsRestAzure

      # @return [Boolean] Whether private access is enabled or not.
      attr_accessor :enabled

      # @return [Array<PrivateAccessVirtualNetwork>] The Virtual Networks (and
      # subnets) allowed to access the site privately.
      attr_accessor :virtual_networks


      #
      # Mapper for PrivateAccess class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PrivateAccess',
          type: {
            name: 'Composite',
            class_name: 'PrivateAccess',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              system_data: {
                client_side_validation: true,
                required: false,
                serialized_name: 'systemData',
                type: {
                  name: 'Composite',
                  class_name: 'SystemData'
                }
              },
              enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.enabled',
                type: {
                  name: 'Boolean'
                }
              },
              virtual_networks: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.virtualNetworks',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'PrivateAccessVirtualNetworkElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'PrivateAccessVirtualNetwork'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
