# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Web::Mgmt::V2020_09_01
  module Models
    #
    # Static Site Build ARM resource.
    #
    class StaticSiteBuildARMResource < ProxyOnlyResource

      include MsRestAzure

      # @return [String] An identifier for the static site build.
      attr_accessor :build_id

      # @return [String] The source branch.
      attr_accessor :source_branch

      # @return [String] The title of a pull request that a static site build
      # is related to.
      attr_accessor :pull_request_title

      # @return [String] The hostname for a static site build.
      attr_accessor :hostname

      # @return [DateTime] When this build was created.
      attr_accessor :created_time_utc

      # @return [DateTime] When this build was updated.
      attr_accessor :last_updated_on

      # @return [BuildStatus] The status of the static site build. Possible
      # values include: 'WaitingForDeployment', 'Uploading', 'Deploying',
      # 'Ready', 'Failed', 'Deleting', 'Detached'
      attr_accessor :status


      #
      # Mapper for StaticSiteBuildARMResource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'StaticSiteBuildARMResource',
          type: {
            name: 'Composite',
            class_name: 'StaticSiteBuildARMResource',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              system_data: {
                client_side_validation: true,
                required: false,
                serialized_name: 'systemData',
                type: {
                  name: 'Composite',
                  class_name: 'SystemData'
                }
              },
              build_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.buildId',
                type: {
                  name: 'String'
                }
              },
              source_branch: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.sourceBranch',
                type: {
                  name: 'String'
                }
              },
              pull_request_title: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.pullRequestTitle',
                type: {
                  name: 'String'
                }
              },
              hostname: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hostname',
                type: {
                  name: 'String'
                }
              },
              created_time_utc: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.createdTimeUtc',
                type: {
                  name: 'DateTime'
                }
              },
              last_updated_on: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastUpdatedOn',
                type: {
                  name: 'DateTime'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.status',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
