# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Web::Mgmt::V2020_09_01
  module Models
    #
    # Static sites user roles invitation resource.
    #
    class StaticSiteUserInvitationRequestResource < ProxyOnlyResource

      include MsRestAzure

      # @return [String] The domain name for the static site custom domain.
      attr_accessor :domain

      # @return [String] The identity provider for the static site user.
      attr_accessor :provider

      # @return [String] The user id for the static site user.
      attr_accessor :user_details

      # @return [String] The roles for the static site user, in free-form
      # string format
      attr_accessor :roles

      # @return [Integer] The number of hours the sas token stays valid
      attr_accessor :num_hours_to_expiration


      #
      # Mapper for StaticSiteUserInvitationRequestResource class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'StaticSiteUserInvitationRequestResource',
          type: {
            name: 'Composite',
            class_name: 'StaticSiteUserInvitationRequestResource',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              system_data: {
                client_side_validation: true,
                required: false,
                serialized_name: 'systemData',
                type: {
                  name: 'Composite',
                  class_name: 'SystemData'
                }
              },
              domain: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.domain',
                type: {
                  name: 'String'
                }
              },
              provider: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.provider',
                type: {
                  name: 'String'
                }
              },
              user_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.userDetails',
                type: {
                  name: 'String'
                }
              },
              roles: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.roles',
                type: {
                  name: 'String'
                }
              },
              num_hours_to_expiration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.numHoursToExpiration',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
